import { ButtonProps } from './button.types';
import { DefineComponent, ComponentOptionsMixin, PublicProps, ExtractPropTypes, PropType } from 'vue';
import { Children } from '../../models/components.model';
import { ButtonSize, ButtonVariant, ButtonIntent } from './button.helper';
import { IconProps } from '../icon/icon.types';

declare function __VLS_template(): {
    default?(_: {}): any;
};
declare const __VLS_component: DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<ButtonProps>, {
    intent: string;
    size: string;
    as: string;
    variant: string;
    disabled: any;
    isLoading: any;
    fluidWidth: any;
    fluid: any;
    className: any;
    attributes: any;
    domAttributes: any;
    buttonRef: any;
    iconSize: any;
    spinnerPlacement: string;
    leftIcon: any;
    children: any;
    rightIcon: any;
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    scroll: (...args: any[]) => void;
    focus: (...args: any[]) => void;
    click: (...args: any[]) => void;
    dblclick: (...args: any[]) => void;
    mousedown: (...args: any[]) => void;
    mouseup: (...args: any[]) => void;
    mouseenter: (...args: any[]) => void;
    mouseleave: (...args: any[]) => void;
    mousemove: (...args: any[]) => void;
    mouseover: (...args: any[]) => void;
    mouseout: (...args: any[]) => void;
    keydown: (...args: any[]) => void;
    keyup: (...args: any[]) => void;
    keypress: (...args: any[]) => void;
    blur: (...args: any[]) => void;
    input: (...args: any[]) => void;
    change: (...args: any[]) => void;
    submit: (...args: any[]) => void;
    reset: (...args: any[]) => void;
    wheel: (...args: any[]) => void;
    dragstart: (...args: any[]) => void;
    drag: (...args: any[]) => void;
    dragend: (...args: any[]) => void;
    dragenter: (...args: any[]) => void;
    dragleave: (...args: any[]) => void;
    dragover: (...args: any[]) => void;
    drop: (...args: any[]) => void;
    touchstart: (...args: any[]) => void;
    touchmove: (...args: any[]) => void;
    touchend: (...args: any[]) => void;
    touchcancel: (...args: any[]) => void;
}, string, PublicProps, Readonly< ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<ButtonProps>, {
    intent: string;
    size: string;
    as: string;
    variant: string;
    disabled: any;
    isLoading: any;
    fluidWidth: any;
    fluid: any;
    className: any;
    attributes: any;
    domAttributes: any;
    buttonRef: any;
    iconSize: any;
    spinnerPlacement: string;
    leftIcon: any;
    children: any;
    rightIcon: any;
}>>> & {
    onDrag?: (...args: any[]) => any;
    onDragend?: (...args: any[]) => any;
    onDragenter?: (...args: any[]) => any;
    onDragleave?: (...args: any[]) => any;
    onDragover?: (...args: any[]) => any;
    onDragstart?: (...args: any[]) => any;
    onDrop?: (...args: any[]) => any;
    onFocus?: (...args: any[]) => any;
    onBlur?: (...args: any[]) => any;
    onChange?: (...args: any[]) => any;
    onInput?: (...args: any[]) => any;
    onReset?: (...args: any[]) => any;
    onSubmit?: (...args: any[]) => any;
    onKeydown?: (...args: any[]) => any;
    onKeypress?: (...args: any[]) => any;
    onKeyup?: (...args: any[]) => any;
    onClick?: (...args: any[]) => any;
    onDblclick?: (...args: any[]) => any;
    onMousedown?: (...args: any[]) => any;
    onMouseenter?: (...args: any[]) => any;
    onMouseleave?: (...args: any[]) => any;
    onMousemove?: (...args: any[]) => any;
    onMouseout?: (...args: any[]) => any;
    onMouseover?: (...args: any[]) => any;
    onMouseup?: (...args: any[]) => any;
    onScroll?: (...args: any[]) => any;
    onTouchcancel?: (...args: any[]) => any;
    onTouchend?: (...args: any[]) => any;
    onTouchmove?: (...args: any[]) => any;
    onTouchstart?: (...args: any[]) => any;
    onWheel?: (...args: any[]) => any;
}, {
    className: string;
    children: Children;
    size: ButtonSize;
    as: "button" | "a";
    attributes: any;
    disabled: boolean;
    domAttributes: any;
    variant: ButtonVariant;
    intent: ButtonIntent;
    fluidWidth: boolean;
    fluid: boolean;
    iconSize: any;
    leftIcon: IconProps["name"];
    rightIcon: IconProps["name"];
    buttonRef: any;
    isLoading: boolean;
    spinnerPlacement: "start" | "end";
}, {}>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, ReturnType<typeof __VLS_template>>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
